View Issue Details

IDProjectCategoryView StatusLast Update
0003730GNUnettransport servicepublic2018-06-07 00:25
ReporteramatusAssigned Toamatus 
PrioritynormalSeveritycrashReproducibilityhave not tried
Status closedResolutionfixed 
Product VersionSVN HEAD 
Target Version0.11.0pre66Fixed in Version0.11.0pre66 
Summary0003730: neighbor message queue corrupted in rev 35419
DescriptionThe transport service had an assertion failure at gnunet-service-transport_neighbours.c:991 trying to remove a message from a neighbor message queue.
GNUNET_assert ( ( (element)->next != NULL) || ((tail) == (element))); failed because mq->next == NULL && n->messages_tail != mq.
Strangely mq->cont == n->messages_tail, both of these objects may be corrupt.
Additional InformationProgram terminated with signal SIGABRT, Aborted.
#0 0xb74d2ddc in __GI_raise (sig=sig@entry=6)
    at ../nptl/sysdeps/unix/sysv/linux/raise.c:56
56 ../nptl/sysdeps/unix/sysv/linux/raise.c: No such file or directory.
(gdb) bt
#0 0xb74d2ddc in __GI_raise (sig=sig@entry=6)
    at ../nptl/sysdeps/unix/sysv/linux/raise.c:56
#1 0xb74d4463 in __GI_abort () at abort.c:89
#2 0xb7678b6b in GNUNET_abort_ () at common_logging.c:289
#3 0x08055ab8 in free_neighbour (n=0x8a317f8)
    at gnunet-service-transport_neighbours.c:991
#4 0x0805d680 in delayed_disconnect (cls=0x8a317f8, tc=0xbff08c34)
    at gnunet-service-transport_neighbours.c:3646
#5 0xb76ac6ca in run_ready (rs=0x82a7c00, ws=0x82a7c88) at scheduler.c:587
#6 0xb76acf58 in GNUNET_SCHEDULER_run (task=0xb76b7ae6 <service_task>,
    task_cls=0xbff08e60) at scheduler.c:867
#7 0xb76b9684 in GNUNET_SERVICE_run (argc=7, argv=0xbff09044,
    service_name=0x8064b28 "transport", options=GNUNET_SERVICE_OPTION_NONE,
    task=0x804c579 <run>, task_cls=0x0) at service.c:1503
#8 0x0804cb50 in main (argc=7, argv=0xbff09044)
    at gnunet-service-transport.c:929
(gdb) p *n
$1 = {messages_head = 0x87508b8, messages_tail = 0xb7612518 <main_arena+280>,
  is_active = 0x0, primary_address = {session = 0x0, address = 0x0,
    connect_timestamp = {abs_value_us = 1427141658688175}, bandwidth_in = {
      value__ = 0}, bandwidth_out = {value__ = 0}, ats_active = 0,
    keep_alive_nonce = 0}, alternative_address = {session = 0x0,
    address = 0x0, connect_timestamp = {abs_value_us = 0}, bandwidth_in = {
      value__ = 0}, bandwidth_out = {value__ = 0}, ats_active = 0,
    keep_alive_nonce = 0}, id = {public_key = {
      q_y = "14\371+\237!\245\245^\255_\244\341\301\005s\002#c\274\326\325\254U\350\241t\333f\251\224\264"}}, task = 0x0, delayed_disconnect_task = 0x0,
  keep_alive_time = {abs_value_us = 1427142159502176}, last_keep_alive_time = {
    abs_value_us = 1427142059502174}, connect_ack_timestamp = {
    abs_value_us = 1427142183899634}, suggest_handle = 0x0, timeout = {
    abs_value_us = 18446744073709551615}, in_tracker = {
    update_cb_cls = 0x8a317f8,
    update_cb = 0x8058af6 <inbound_bw_tracker_update>, excess_cb_cls = 0x0,
    excess_cb = 0x0, consumption_since_last_update__ = 28168,
    excess_task = 0x0, last_update__ = {abs_value_us = 1427142053432873},
    available_bytes_per_s__ = 1930, max_carry_s__ = 5},
  quota_violation_count = 0, neighbour_receive_quota = {value__ = 209136649},
  state = GNUNET_TRANSPORT_PS_DISCONNECT_FINISHED,
  expect_latency_response = 1, ack_state = ACK_SEND_ACK,
  util_total_bytes_sent = 0, util_total_bytes_recv = 1220,
  last_util_transmission = {abs_value_us = 1427142066870872}}
(gdb) p *mq
$2 = {next = 0x0, prev = 0xf1, cont = 0xb7612518 <main_arena+280>,
  cont_cls = 0x8a317f0, message_buf = 0x0, message_buf_size = 0, timeout = {
    abs_value_us = 0}}
TagsNo tags attached.

Activities

Christian Grothoff

2015-06-24 21:13

manager   ~0009335

I would be surprised if this isn't also fixed by SVN 35980 (from amatus).

Issue History

Date Modified Username Field Change
2015-03-24 15:27 amatus New Issue
2015-03-24 15:27 amatus Status new => assigned
2015-03-24 15:27 amatus Assigned To => Matthias Wachs
2015-06-24 21:13 Christian Grothoff Assigned To Matthias Wachs => amatus
2015-06-24 21:13 Christian Grothoff Note Added: 0009335
2015-06-24 21:13 Christian Grothoff Status assigned => resolved
2015-06-24 21:13 Christian Grothoff Fixed in Version => 0.11.0pre66
2015-06-24 21:13 Christian Grothoff Resolution open => fixed
2015-06-24 21:13 Christian Grothoff Target Version => 0.11.0pre66
2018-06-07 00:25 Christian Grothoff Status resolved => closed